/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.configuracioneccomerciales.cyberviaje;

import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.ProdClaseServicio;
import com.rjconsultores.ventaboletos.service.ClaseServicioService;
import com.rjconsultores.ventaboletos.service.ProdClaseServicioService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import java.util.Calendar;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Messagebox;

/**
 *
 * @author Administrador
 */
@Controller("editarProdClaseServicioController")
@Scope("prototype")
public class EditarProdClaseServicioController extends MyGenericForwardComposer {

    @Autowired
    private ProdClaseServicioService prodClaseServicioService;
    @Autowired
    private ClaseServicioService claseServicioService;
    private List<ClaseServicio> lsClaseServicio;
    private MyListbox prodClaseServicioList;
    private Combobox cmbClaseServicio;
    private ProdClaseServicio prodClaseServicio;
    private List<ProdClaseServicio> lsProdClaseServicio;
    private static Logger log = Logger.getLogger(EditarProdClaseServicioController.class);

    public List<ClaseServicio> getLsClaseServicio() {
        return lsClaseServicio;
    }

    public void setLsClaseServicio(List<ClaseServicio> lsClaseServicio) {
        this.lsClaseServicio = lsClaseServicio;
    }

    public ProdClaseServicio getProdClaseServicio() {
        return prodClaseServicio;
    }

    public void setProdClaseServicio(ProdClaseServicio prodClaseServicio) {
        this.prodClaseServicio = prodClaseServicio;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        lsClaseServicio = claseServicioService.obtenerTodos();
        lsProdClaseServicio = (List<ProdClaseServicio>) Executions.getCurrent().getArg().get("lsProdClaseServicio");
        prodClaseServicio = (ProdClaseServicio) Executions.getCurrent().getArg().get("prodClaseServicio");
        prodClaseServicioList = (MyListbox) Executions.getCurrent().getArg().get("prodClaseServicioList");

        super.doAfterCompose(comp);
    }

    public void onClick$btnAdicionar(Event ev) throws Exception {

        cmbClaseServicio.getValue();

        try {

            if (prodClaseServicio.getClaseServicio() == null) {
                Messagebox.show(
                        Labels.getLabel("MSG.Error.combobox"),
                        Labels.getLabel("editarProductoServicioController.windowProdClaseServicio.title"),
                        Messagebox.OK, Messagebox.ERROR);
                return;
            }

            if (prodClaseServicio.getProdclaseservicioId() != null) {
                if (registroDuplicado()) {
                    Messagebox.show(
                            Labels.getLabel("editarPricingController.MSG.categoriaExiste"),
                            Labels.getLabel("editarProductoServicioController.windowProdClaseServicio.title"),
                            Messagebox.OK, Messagebox.EXCLAMATION);
                    return;
                }
                prodClaseServicioService.actualizacion(prodClaseServicio);
                prodClaseServicioList.updateItem(prodClaseServicio);
                lsProdClaseServicio.add(prodClaseServicio);
            } else {
                if (registroDuplicado()) {
                    Messagebox.show(
                            Labels.getLabel("editarPricingController.MSG.categoriaExiste"),
                            Labels.getLabel("editarProductoServicioController.windowProdClaseServicio.title"),
                            Messagebox.OK, Messagebox.EXCLAMATION);
                    return;
                }
                prodClaseServicioService.suscribir(prodClaseServicio);
                prodClaseServicioList.addItem(prodClaseServicio);
                lsProdClaseServicio.add(prodClaseServicio);
            }

            closeWindow();
        } catch (Exception ex) {
            log.error(ex);
        }
    }

    private boolean registroDuplicado() throws InterruptedException {
        for (ProdClaseServicio p : lsProdClaseServicio) {
            if (!p.getActivo()){
                continue;
            }
            if (p.getClaseServicio().getDescclase().equals(prodClaseServicio.getClaseServicio().getDescclase())) {
                return true;
            }
        }
        return false;
    }

    public void onClick$btnRemover(Event ev) {
        try {
            Integer resp = Messagebox.show(
                    Labels.getLabel("editarProdClaseServicioController.MSG.borrarPergunta"),
                    Labels.getLabel("editarProductoServicioController.windowProdClaseServicio.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp.equals(Messagebox.YES)) {
                prodClaseServicio.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                prodClaseServicio.setFecmodif(Calendar.getInstance().getTime());
                prodClaseServicio.setActivo(Boolean.FALSE);

                prodClaseServicioList.removeItem(prodClaseServicio);
                prodClaseServicioService.borrar(prodClaseServicio);

                Messagebox.show(
                        Labels.getLabel("editarProdClaseServicioController.MSG.borrarSucesso"),
                        Labels.getLabel("editarProductoServicioController.windowProdClaseServicio.title"),
                        Messagebox.YES, Messagebox.EXCLAMATION);

                closeWindow();
            }

        } catch (Exception ex) {
            log.error(ex);
        }
    }

    public Combobox getCmbClaseServicio() {
        return cmbClaseServicio;
    }

    public void setCmbClaseServicio(Combobox cmbClaseServicio) {
        this.cmbClaseServicio = cmbClaseServicio;
    }

    /**
     * @return the lsProdClaseServicio
     */
    public List<ProdClaseServicio> getLsProdClaseServicio() {
        return lsProdClaseServicio;
    }

    /**
     * @param lsProdClaseServicio the lsProdClaseServicio to set
     */
    public void setLsProdClaseServicio(List<ProdClaseServicio> lsProdClaseServicio) {
        this.lsProdClaseServicio = lsProdClaseServicio;
    }
}
